<?php

namespace App\Http\Controllers\Wap\Crm;

use App\Modules\User\Services\ReadRecordService;
use Illuminate\Http\Request;
use App\Modules\Subscribe\Services\OrderService;
use App\Modules\User\Services\UserDivisionCpcPropertyService;
use App\Modules\User\Services\ForceGuidePersonAccountService;
use App\Http\Controllers\Wap\BaseController;
use App\Modules\User\Services\UserService;
use App\Modules\User\Services\UserBindHkWelfareService;
use Log;
use Redis;
use Cookie;
use DB;
use Hashids;

class CrmGuideFansController extends BaseController
{
    private $crm_one_day_exposure_limit;
    private $crm_one_time_exposure_limit;
    private $now_personal_account_info;
    private $crm_now_exposure_uv;
    /**
     * 主动导粉
     * @param Request $request
     * @param $channel_id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View}
     */
    public function activeGuidePersonalAccountV2(Request $request){
        $uid = $this->uid;
        $fee = $request->get('fee',200);
        $group = $request->get('group','ACTIVE');
        $page = 'jump.guidePersonalAccountOurs';
        if(in_array($group,['ACTIVE_YEAR','ACTIVE_MONTH'])){
            $page = 'crm.vipguidePersonalAccount';
        }

        $old_id = ReadRecordService::getByField($uid,'person_account_id');
        if($old_id){
            $old_personal_info = DB::table('personal_account_list')->where('id',$old_id)->first();
            if($old_personal_info && $old_personal_info->is_enable == 1){
                return view($page,['img'=>$old_personal_info->url,'name'=>$old_personal_info->name,'fee'=>$fee]);
            }
        }
        list($img,$max,$now_id,$one_loop_max) = redisEnvMulti(strtoupper($group).'_GUIDE_PERSONAL_ACCOUNT_OURS_QRCODE',
            strtoupper($group).'_GUIDE_PERSONAL_ACCOUNT_MAX_UV',strtoupper($group).'_GUIDE_PERSONAL_ACCOUNT_ID',
            strtoupper($group).'_GUIDE_PERSONAL_ACCOUNT_MAX_EVERY_UV');
        if(empty($img) || empty($now_id)){
            return back();
        }
        $personal_info = DB::table('personal_account_list')->where('id',$now_id)->select('id','name','count','status','url','group')->first();
        if(!$personal_info){
            return back();
        }
        $this->now_personal_account_info = $personal_info;
        //单日曝光上线
        $max = (int)(empty($max)?100:$max);
        $this->crm_one_day_exposure_limit = $max;
        //单次曝光上线
        $one_loop_max = empty($one_loop_max)?10:$one_loop_max;
        $this->crm_one_time_exposure_limit = $one_loop_max;
        $uv_key = strtolower($group).'_guide_personal_uv';
        $uv = Redis::scard($uv_key);
        $this->crm_now_exposure_uv = $uv;

        $this->crmGuideProcess();
        if(!$this->now_personal_account_info){
            return back();
        }
        if($group == 'OUT_ACTIVE'){
            $user = UserService::getById($uid);
            Redis::hset('crm:out_guide_exposure_user',$user->openid,$uid);
        }
        ReadRecordService::setByField($uid,'person_account_id',$this->now_personal_account_info->id);
        $name = $this->now_personal_account_info->name;
        $img = $this->now_personal_account_info->url;
        $time = strtotime(date('Y-m-d',time()+86400))-time();
        //Cookie::queue('crm_person_img', $img,$time);
        //Cookie::queue('crm_person_name', $name,$time);
        return view($page,['img'=>$img,'name'=>$name,'fee'=>$fee]);
    }

    /**
     * 强制导粉
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\Http\RedirectResponse|\Illuminate\View\View
     */
    public function forceGuidePersonalAccountV2(Request $request)
    {
        $bid = $request->get('bid');
        $cid = $request->get('cid');
        $prev_cid = $request->get('prev_cid');
        $book_name = $request->get('book_name');
        $bid_no = Hashids::decode($bid)[0];
        $group = $request->get('group','FORCE');
        /*if (Redis::SISMEMBER('crm:out_channel_sites', $this->distribution_channel_id)) {
            $group = 'OUT_FORCE';
        } else {
            $group = 'FORCE';
        }*/
        list($img,$max,$now_id,$one_loop_max) = redisEnvMulti($group . '_GUIDE_PERSONAL_ACCOUNT_OURS_QRCODE', $group . '_GUIDE_PERSONAL_ACCOUNT_MAX_UV',
            $group . '_GUIDE_PERSONAL_ACCOUNT_ID', $group . '_GUIDE_PERSONAL_ACCOUNT_MAX_EVERY_UV');
        $personal_info = DB::table('personal_account_list')->where('id',$now_id)->select('id','name','count','status','url','group')->first();
        if(!$personal_info){
            return back();
        }
        $this->now_personal_account_info = $personal_info;
        //单日曝光上线
        $max = (int)(empty($max)?100:$max);
        $this->crm_one_day_exposure_limit = $max;
        //单次曝光上线
        $one_loop_max = empty($one_loop_max)?10:$one_loop_max;
        $this->crm_one_time_exposure_limit = $one_loop_max;
        $uv_key = strtolower($group).'_guide_personal_uv';
        $uv = Redis::scard($uv_key);
        $this->crm_now_exposure_uv = $uv;
        $this->crmGuideProcess();

        if ($group == 'OUT_FORCE') {
            $data = UserService::getById($this->uid);
            Redis::hset('crm:out_guide_exposure_user', $data->openid, $this->uid);
        }

        $img = $this->now_personal_account_info->url;
        ForceGuidePersonAccountService::create($this->uid, $bid_no, $cid);

        $link['next'] = sprintf('/reader?bid=%s&cid=%s', $bid, $cid);
        $link['prev'] = sprintf('/reader?bid=%s&cid=%s', $bid, $prev_cid);
        $link['catalog'] = sprintf('/catalog?id=%s', $bid);

        return view('jump.forceGuidePersonalAccountV2', ['img' => $img, 'link' => $link, 'title' => $book_name, 'name' => $this->now_personal_account_info->name]);
    }

    private function crmGuideProcess(){
        $group = strtoupper($this->now_personal_account_info->group);
        $total_max = $this->crm_now_exposure_uv+$this->now_personal_account_info->count;
        if($this->crm_now_exposure_uv >= $this->crm_one_time_exposure_limit || $total_max >= $this->crm_one_day_exposure_limit){
            if($total_max>= $this->crm_one_day_exposure_limit){
                DB::table('personal_account_list')->where('id',$this->now_personal_account_info->id)->update([
                    'status'=>2,
                    'count'=>$total_max,
                    'updated_at'=>date('Y-m-d H:i:s')
                ]);
            }else{
                DB::table('personal_account_list')->where('id',$this->now_personal_account_info->id)->increment('count',$this->crm_now_exposure_uv,[
                    'updated_at'=>date('Y-m-d H:i:s')
                ]);
            }

            $account = DB::table('personal_account_list')
                ->where('is_enable',1)
                ->whereIn('status',[1,0])
                ->select('id','name','count','status','url','group')
                ->where('group',$this->now_personal_account_info->group)
                ->where('count','<',$this->crm_one_day_exposure_limit)
                ->orderBy('count','asc')
                ->orderBy('id')
                ->first();

            Redis::del(strtolower($group) . '_guide_personal_uv');
            if($account){
                DB::table('personal_account_list')->where('id',$account->id)->update([
                    'status'=>1,
                    'updated_at'=>date('Y-m-d H:i:s')
                ]);
                $this->now_personal_account_info = $account;
                Redis::Hmset('env',$group.'_GUIDE_PERSONAL_ACCOUNT_OURS_QRCODE',$account->url,$group.'_GUIDE_PERSONAL_ACCOUNT_ID',$account->id);
            }else{
                Redis::Hmset('env',$group.'_GUIDE_PERSONAL_ACCOUNT_OURS_QRCODE','',$group.'_GUIDE_PERSONAL_ACCOUNT_ID','');
                $this->now_personal_account_info= null;
            }
        }
        if($this->now_personal_account_info){
            Redis::sadd(strtolower($group) . '_guide_personal_uv',$this->uid);
            DB::table('ad_pdd')->insert([
                'uid'=>$this->uid,
                'img'=>strtoupper($group).'_PERSONAL_ACCOUNT_'.$this->now_personal_account_info->id,
                'date'=>date('Y-m-d'),
                'created_at'=>date('Y-m-d H:i:s'),
                'updated_at'=>date('Y-m-d H:i:s')
            ]);
        }
    }


    public function crmPushView(Request $request)
    {
        $crm_config = redisEnvMulti('ACTIVE_GUIDE_PERSONAL_ACCOUNT_OURS_QRCODE',
            'ACTIVE_GUIDE_PERSONAL_ACCOUNT_MAX_UV', 'ACTIVE_GUIDE_PERSONAL_ACCOUNT_ID',
            'ACTIVE_GUIDE_PERSONAL_ACCOUNT_MAX_EVERY_UV');
        $img = $crm_config[0];
        $max = empty($crm_config[1]) ? 100 : $crm_config[1];
        $max = (int)$max;
        $one_loop_max = empty($crm_config[3]) ? 10 : $crm_config[3];
        $now_id = (int)$crm_config[2];
        $uv_key = 'active_guide_personal_uv';
        $uv = Redis::scard($uv_key);
        $personal_info = DB::table('personal_account_list')->where('id', $now_id)->select('id','count','name')->first();
        $total_max = (int)($personal_info->count + $uv);
        if (empty($img) || empty($now_id) || $total_max >= $max) {
            //没有名额
            $data = ['code' => -1, 'read_url' => '/sign'];
            return view('crm.crmPush', $data);
        }
        $sql = 'SELECT friend_link_uid_bind.uid FROM friend_link_uid_bind where openid = (SELECT openid FROM users WHERE id = %s) ORDER by id desc limit 1';
        $friend_link_uid_bind = DB::select(sprintf($sql, $this->uid));
        //$get_info = UserBindHkWelfareService::isHasGet($this->uid);
        if ($friend_link_uid_bind) {
            $info = DB::table('ad_pdd')->where('uid', $friend_link_uid_bind[0]->uid)->orderBy('id', 'desc')->first();
            if ($info) {
                $personal_account_id = preg_replace('/\D+/', '', $info->img);
                if ($info) {
                    $personal_info = DB::table('personal_account_list')
                        ->where('id', $personal_account_id)
                        ->where('is_enable', 1)
                        ->select('name', 'url', 'status', 'is_enable')->first();
                    if ($personal_info) {
                        $data = ['code' => -2, 'name' => $personal_info->name];
                        return view('crm.crmPush', $data);
                    }
                }
            }
            $user_info = UserService::getById($friend_link_uid_bind[0]->uid);
            $link = 'https://site'.encodeDistributionChannelId($user_info->distribution_channel_id).'.leyuee.com/sign';
            $data = ['code' => -3, 'read_url' => $link];
            return view('crm.crmPush', $data);
        }
        $property = UserDivisionCpcPropertyService::getUserPropertyV2($this->uid);
        $charge = false;
        if (in_array($property, ['medium', 'high'])) {
            $charge = true;
        } else {
            if ($this->property == 'undefined' && OrderService::getChargeNum($this->uid) >= 10) {
                $charge = true;
            }
        }
        if (!$charge) {
            //不符合条件
            $data = ['code' => -1, 'read_url' => '/sign'];
            return view('crm.crmPush', $data);
        }

        Redis::sadd($uv_key, $this->uid);

        DB::table('ad_pdd')->insert([
            'uid' => $this->uid,
            'img' => 'GUIDE_PERSONAL_ACCOUNT_' . $now_id,
            'date' => date('Y-m-d'),
            'created_at' => date('Y-m-d H:i:s'),
            'updated_at' => date('Y-m-d H:i:s')
        ]);
        return view('crm.crmPush2', ['name' => $personal_info->name, 'img' => $img]);
    }
}
